
; CC5X Version 3.2K, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  30. Dec 2007  11:35  *************

	processor  16F819
	radix  DEC

	__config 0x3F38

TMR0        EQU   0x01
STATUS      EQU   0x03
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
INTCON      EQU   0x0B
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
RBIF        EQU   0
GIE         EQU   7
OPTION_REG  EQU   0x81
T1CON       EQU   0x10
ADRESH      EQU   0x1E
ADCON0      EQU   0x1F
OSCCON      EQU   0x8F
ADRESL      EQU   0x9E
ADCON1      EQU   0x9F
ADON        EQU   0
GO          EQU   2
dummy       EQU   0x24
dummy2      EQU   0x25
Motorstrom  EQU   0x26
med_a       EQU   0x27
med_b       EQU   0x28
med_c       EQU   0x29
soll_status EQU   0x2A
result      EQU   0x2B
i           EQU   0x2C
laufzeit    EQU   0x2D
takt        EQU   0x2E
cyc         EQU   0x2F
duty        EQU   0x30
svrWREG     EQU   0x70
svrSTATUS   EQU   0x20
ms          EQU   0x22
akt_status  EQU   0x21

	GOTO main

  ; FILE C:\projekte\picsel\anks\anks.c
			;/* ANKS Anklappssteuerung fuer Aussenspiegel                        */
			;/*                       __    _                                    */                     
			;/*            __________/ /_  (_)________   ___  __  __             */       
			;/*           / ___/ ___/ __ \/ / ___/ __ \ / _ \/ / / /             */ 
			;/*          (__  ) /__/ / / / / /  / /_/ //  __/ /_/ /              */ 
			;/*         /____/\___/_/ /_/_/_/  / .___(_)___/\__,_/               */ 
			;/*                               /_/                                */ 
			;/*                                                                  */ 
			;/* (c) C.Schirp  released for non-commercial use                    */
			;/*     this header must be distributed with this source code        */ 
			;/*     schirp.eu must be named in derived software coyright notes   */
			;/*                                                                  */
			;/* V1.0 Erstausgabe                                                 */
			;/* V1.1 nderung der Unterspannungserkennung HW1.3 erforderlich     */
			;/* V1.2 Entprellen der Eingangsinale, schneller Wechsel in Sleep    */
			;/*                                                                  */
			;/*                                                                  */
			;
			;#include <c:\projekte\picsel\cc5\16F819.h>
			;#include <c:\projekte\picsel\cc5\int16CXX.h>
			;#include <c:\projekte\picsel\cc5\inline.h>
			;
			;#pragma config = 0x3F38 
			;// INTIO2
			;
			;
			;/* Port- Defines */
			;
			;#define TR1    0b.0001.0000	// PA Transistor 1 (L) linkslauf
			;#define TR2    0b.0000.1000	// PA Transistor 2 (L) rechtslauf
			;#define TR3    0b.0000.0100	// PA Transistor 3 (H) rechtslauf
			;#define TR4    0b.0000.0010	// PA Transistor 4 (H) linkslauf
			;
			;#define IN_UNTER  0b.0100.0000	// PA Unterspannungssignal IN
			;#define PU_UNTER  0b.1000.0000	// PA Unterspannungssignal Pullup
			;
			;
			;#define INP_A  0b.0001.0000	// PB Eingang A
			;#define INP_B  0b.0010.0000	// PB Eingang B
			;#define INP_AB 0b.0011.0000	// PB beide Eingaenge
			;
			;
			;/* Programmkonstanten */
			;#define MOTORSTROM_H	80	// 1,2A x 0,33R
			;#define MOTORSTROM_L	10	// 1,2A x 0,33R
			;#define MOTORZEIT_H	60	// Max laufzeit in 100ms-Schritten
			;
			;#define	ST_IDLE		0	// Stati-Defines
			;#define ST_ANKLAPP	1
			;#define ST_AUSKLAPP	2
			;
			;#define END_STROM	0xFF	// Werte fr Abbruch eines Klappvorganges in main()
			;#define END_ZEIT	0xFE
			;#define END_RICHTUNG	0xFD
			;#define END_SLEEP	0xDC
			;
			;
			;#define PWM_MAX  100		// Max-Tastgrad/Auflsung fuer Soft-PWM
			;
			;
			;
			;/* Funktionsprototypen */
			;void Eingang_testen(void);
			;
			;/* Variablen */
			;uns8 dummy, dummy2;	// Hilfsvariablen
			;
			;uns8 Motorstrom;	// Ergebnis des Medianfilters
			;uns8 med_a;		// Filterwerte
			;uns8 med_b;
			;uns8 med_c;
			;
			;uns8 soll_status;	// Resultat der Eingangspegelauswertung
			;uns8 result;		// Zwischenergebnis der Eingangsauswertung
			;uns8 i;			// for-index fuer Verzoegerung in Eingangsauswertung
			;
			;uns8 laufzeit;		// Zhler fr die Laufzeitberwachung in main()
			;
			;uns8 takt, cyc, duty;	// Fuer Soft-PWM
			;
			;bank0 uns8 Blink:1;	// Bitcounter 
			;
			;/*------------------------------------------------------------------*/
			;/*   II  N   N TTTTT                                                */
			;/*   II  NN  N   T                                                  */
			;/*   II  N N N   T                                                  */
			;/*   II  N  NN   T                                                  */
			;/*   II  N   N   T                                                  */
			;/*------------------------------------------------------------------*/
			;#pragma origin 4
	ORG 0x0004
			;interrupt int_server(void)
			;{
int_server
			;	int_save_registers
	MOVWF svrWREG
	SWAPF STATUS,W
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF svrSTATUS
			;	
			;	// wenn int-on-change, dann status auswerten
			;	Eingang_testen();
	CALL  Eingang_testen
			;	
			;	
			;	int_restore_registers
	BCF   0x03,RP0
	BCF   0x03,RP1
	SWAPF svrSTATUS,W
	MOVWF STATUS
	SWAPF svrWREG,1
	SWAPF svrWREG,W
			;}
	RETFIE
			;
			;
			;
			;/*------------------------------------------------------------------*/
			;/*   II  N   N  II TTTTT                                            */
			;/*   II  NN  N  II   T                                              */
			;/*   II  N N N  II   T                                              */
			;/*   II  N  NN  II   T                                              */
			;/*   II  N   N  II   T                                              */
			;/*------------------------------------------------------------------*/
			;
			;void init (void)
			;{
init
			;	/* Oszillatorblock */
			;	
			;	OSCCON = 0b0110.0000;	// 4MHz Clock - wie 16F628 mit INTRC
	MOVLW .96
	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVWF OSCCON
			;	
			;	/* PORT A, B Config */
			;	PORTA =  0x00;	
	BCF   0x03,RP0
	CLRF  PORTA
			;	ADCON1 = 0b1000.1110;	// AD-Wandler rechtsbuendig, Clk, nur PIN AN0
	MOVLW .142
	BSF   0x03,RP0
	MOVWF ADCON1
			;	TRISA =  0b0110.0001;	// RA0, 5 und 6 input
	MOVLW .97
	MOVWF TRISA
			;	
			;	PORTB =  0b0000.0000;	//
	BCF   0x03,RP0
	CLRF  PORTB
			;	TRISB =  0b0011.0000; 	// 4 Inp_A, 5 Inp_b, Rest Ausgang
	MOVLW .48
	BSF   0x03,RP0
	MOVWF TRISB
			;
			;	/* ADC */
			;	
			;	ADCON0=	 0b0100.0000;	// Fosc/8, Channel AN0, Stopped, AD_ON
	MOVLW .64
	BCF   0x03,RP0
	MOVWF ADCON0
			;
			;	/*sonstiges*/
			;	T1CON = 0x00;		// Timer disabled
	CLRF  T1CON
			;	OPTION_REG = 0x04;	/* pull-up portB, falling edge int, no WDT prescaler, prescale=32 */
	MOVLW .4
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;	INTCON = 0b.0000.1000; 	// int disabled und gelscht nur Int-on-change aktiv
	MOVLW .8
	MOVWF INTCON
			;
			;	/* Variablen initialisieren */
			;
			;	med_a = MOTORSTROM_L;
	MOVLW .10
	BCF   0x03,RP0
	MOVWF med_a
			;	med_b = MOTORSTROM_L;
	MOVLW .10
	MOVWF med_b
			;	med_c = MOTORSTROM_L;
	MOVLW .10
	MOVWF med_c
			;	
			;	soll_status = ST_IDLE;	
	CLRF  soll_status
			;	
			;}
	RETURN
			;
			;/*------------------------------------------------------------------*/
			;/*                                                                  */
			;/*                                                                  */
			;/*                                                                  */
			;/*                                                                  */
			;/*                                                                  */
			;/*------------------------------------------------------------------*/
			;
			;//
			;// Pause fr ms Milisekunden
			;//
			;void Delay1ms(uns16 ms)
			;{
Delay1ms
			;	while(ms)				// Schleife verlassen wen ms=0 ist
m001	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  ms,W
	IORWF ms+1,W
	BTFSC 0x03,Zero_
	GOTO  m004
			;	{
			;	    OPTION = 2; 		// Vorteiler auf 8 einstellen
	MOVLW .2
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;	    TMR0 = 131; 		// 125 * 8 = 1000 (= 1 ms)
	MOVLW .131
	BCF   0x03,RP0
	MOVWF TMR0
			;	    while (TMR0);		// abwarten einer Milisekunde
m002	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  TMR0,W
	BTFSC 0x03,Zero_
	GOTO  m003
	GOTO  m002
			;	    ms--;				// "ms" mit jeder Milisekunde ernidrigen
m003	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  ms,1
	INCF  ms,W
	BTFSC 0x03,Zero_
	DECF  ms+1,1
			;	}
	GOTO  m001
			;}
m004	RETURN
			;
			;//
			;// 3-Tap Medianfilter fr die Motorstromwerte
			;// ltestes Element ist a, neuestes ist c
			;//
			;void MedianFilter(void)
			;{
MedianFilter
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;  // Medianfilter 
			;
			;  if (med_a>med_b)
	MOVF  med_a,W
	SUBWF med_b,W
	BTFSC 0x03,Carry
	GOTO  m008
			;   if (med_a<med_c)
	MOVF  med_c,W
	SUBWF med_a,W
	BTFSC 0x03,Carry
	GOTO  m005
			;    Motorstrom = med_a;
	MOVF  med_a,W
	MOVWF Motorstrom
			;   else
	GOTO  m007
			;    if (med_b<med_c)
m005	MOVF  med_c,W
	SUBWF med_b,W
	BTFSC 0x03,Carry
	GOTO  m006
			;     Motorstrom = med_c;
	MOVF  med_c,W
	MOVWF Motorstrom
			;    else
	GOTO  m007
			;     Motorstrom = med_b;
m006	MOVF  med_b,W
	MOVWF Motorstrom
			;  else
m007	GOTO  m011
			;   if (med_a>med_c)
m008	MOVF  med_a,W
	SUBWF med_c,W
	BTFSC 0x03,Carry
	GOTO  m009
			;    Motorstrom = med_a;
	MOVF  med_a,W
	MOVWF Motorstrom
			;   else
	GOTO  m011
			;    if (med_b<med_c)
m009	MOVF  med_c,W
	SUBWF med_b,W
	BTFSC 0x03,Carry
	GOTO  m010
			;     Motorstrom = med_b;
	MOVF  med_b,W
	MOVWF Motorstrom
			;    else
	GOTO  m011
			;     Motorstrom = med_c;
m010	MOVF  med_c,W
	MOVWF Motorstrom
			;     
			;   
			;   // Werteliste weiterschieben
			;   med_a = med_b;
m011	MOVF  med_b,W
	MOVWF med_a
			;   med_b = med_c;
	MOVF  med_c,W
	MOVWF med_b
			;     
			;#pragma updateBank 1 /* OFF, all cores */
			;}
	RETURN
			;
			;//
			;// Testen der Eingnge INP_A, INP_B und UNTER
			;// setzen des Soll-Modus
			;//
			;void Eingang_testen(void)
			;{
Eingang_testen
			;	
			;
			;	// hier etwas warten
			;	for (i = 0; i <200; i++)
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  i
m012	MOVLW .200
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF i,W
	BTFSC 0x03,Carry
	GOTO  m013
			;	{
			;		nop();
	NOP  
			;	}
	INCF  i,1
	GOTO  m012
			;	
			;	result = PORTB;		// Port lesen
m013	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PORTB,W
	MOVWF result
			;	RBIF = 0;	// Int on change-Request loeschen
	BCF   0x0B,RBIF
			;	
			;	result &= INP_AB;	// Eingnge maskieren
	MOVLW .48
	ANDWF result,1
			;		
			;	switch (result)
	MOVF  result,W
	XORLW .16
	BTFSC 0x03,Zero_
	GOTO  m014
	XORLW .48
	BTFSC 0x03,Zero_
	GOTO  m015
	GOTO  m016
			;	{
			;		case INP_A: soll_status = ST_AUSKLAPP; break;
m014	MOVLW .2
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF soll_status
	GOTO  m017
			;		case INP_B: soll_status = ST_ANKLAPP; break;
m015	MOVLW .1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF soll_status
	GOTO  m017
			;		default: break;
m016	GOTO  m017
			;	}
			;}
m017	RETURN
			;
			;//
			;// Sleepmode-Entry mit Abschalten der Peripherie
			;// und Rcksetzen der Portchange-Bedingungen
			;//
			;void goto_sleep(void)
			;{
goto_sleep
			;	
			;	dummy = PORTB;	// Portb lesen fuer Reset des Wakeup on change
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PORTB,W
	MOVWF dummy
			;	RBIF = 0;	// Portchange-Request loeschen
	BCF   0x0B,RBIF
			;	GIE = 0;	// Global Int sperren
	BCF   0x0B,GIE
			;	
			;	ADON = 0; 	// ADC ausschalten
	BCF   0x1F,ADON
			;	sleep();
	SLEEP
			;	
			;	RBIF = 0;	// Portchange-Request loeschen
	BCF   0x0B,RBIF
			;	GIE = 1;	// Global Int freigeben	
	BSF   0x0B,GIE
			;	
			;	// Todo: entweder hier etwas warten...oder in eingang_testen()
			;}
	RETURN
			;
			;
			;//
			;// Soft-PWM fuer rechts- und linkslauf
			;// Portmuster bergeben in dummy und dummy2
			;//
			;void do_pwm(void)
			;{
do_pwm
			;	for (takt = 0; takt<PWM_MAX; takt++)
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  takt
m018	MOVLW .100
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF takt,W
	BTFSC 0x03,Carry
	GOTO  m023
			;	{
			;		duty = PWM_MAX-takt;
	MOVF  takt,W
	SUBLW .100
	MOVWF duty
			;	
			;		PORTA &= dummy;	// Off
	MOVF  dummy,W
	ANDWF PORTA,1
			;	
			;		for ( cyc = 0; cyc < duty; cyc++)
	CLRF  cyc
m019	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  duty,W
	SUBWF cyc,W
	BTFSC 0x03,Carry
	GOTO  m020
			;		{
			;			nop();
	NOP  
			;		}
	INCF  cyc,1
	GOTO  m019
			;	
			;		PORTA |= dummy2;	//On
m020	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  dummy2,W
	IORWF PORTA,1
			;		
			;		for ( cyc = duty; cyc < PWM_MAX; cyc++)
	MOVF  duty,W
	MOVWF cyc
m021	MOVLW .100
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF cyc,W
	BTFSC 0x03,Carry
	GOTO  m022
			;		{
			;			nop();
	NOP  
			;		}
	INCF  cyc,1
	GOTO  m021
			;	
			;	}
m022	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  takt,1
	GOTO  m018
			;}
m023	RETURN
			;
			;//
			;// Start des Anklappvorganges, Aufruf der Soft-PWM
			;// Portmuster werden bergeben in dummy und dummy2
			;//
			;void anklappen(void)
			;{
anklappen
			;	PORTA = 0;	// Alle Treiber aus
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  PORTA
			;	Delay1ms(1);	// 1ms warten
	MOVLW .1
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;	
			;	// erst Highside und Pullup fr Kompartor an
			;	PORTA = TR4 + PU_UNTER;
	MOVLW .130
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF PORTA
			;	Delay1ms(1);	// 1ms warten
	MOVLW .1
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;	
			;	//
			;	// PWM-Rampe mit steigender ON-Zeit 0..100
			;	//
			;	dummy = 0xff - TR1; 	// Off
	MOVLW .239
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF dummy
			;	dummy2 = TR1;		// On
	MOVLW .16
	MOVWF dummy2
			;	
			;	// Wenn Spannung am Drain von T3 okay, dann anklappen
			;	if (PORTA & IN_UNTER)
	BTFSS PORTA,6
	GOTO  m024
			;	{	
			;		do_pwm();
	CALL  do_pwm
			;		laufzeit = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  laufzeit
			;	}
			;	else // ansonsten nichts tun
	GOTO  m025
			;	{
			;		soll_status = ST_IDLE;
m024	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  soll_status
			;	}
			;
			;}
m025	RETURN
			;
			;//
			;// Start des Ausklappvorganges, Aufruf der Soft-PWM
			;// Portmuster werden bergeben in dummy und dummy2
			;//
			;void ausklappen(void)
			;{
ausklappen
			;	PORTA = 0;	// Alle Treiber aus
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  PORTA
			;	Delay1ms(1);	// 1ms warten
	MOVLW .1
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;	
			;	// erst Highside an, dann Lowside
			;	PORTA = TR3;
	MOVLW .4
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF PORTA
			;	Delay1ms(1);	// 1ms warten
	MOVLW .1
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;	
			;	//
			;	// PWM-Rampe mit steigender ON-Zeit 0..100
			;	//
			;	
			;	dummy = 0xff - TR2;	// off
	MOVLW .247
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF dummy
			;	dummy2 = TR2;		// on
	MOVLW .8
	MOVWF dummy2
			;	
			;	do_pwm();
	CALL  do_pwm
			;	laufzeit = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  laufzeit
			;
			;}
	RETURN
			;
			;//
			;// Motor-Stopp mit beiden Lowside-Treibern
			;// Reset der Motorstrom-Filterwerte
			;//
			;void motor_stop(void)
			;{
motor_stop
			;	PORTA = 0;	// Alle Treiber und Pullup aus
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  PORTA
			;	Delay1ms(1);	// 1ms warten
	MOVLW .1
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;	
			;	PORTA = TR1 + TR2;	// Lowside-Treiber beide an
	MOVLW .24
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF PORTA
			;	Delay1ms(100);
	MOVLW .100
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;	PORTA = 0;	// Alle Treiber aus
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  PORTA
			;	
			;	med_a = MOTORSTROM_L;	// Filterwerte loeschen
	MOVLW .10
	MOVWF med_a
			;	med_c = MOTORSTROM_L;	
	MOVLW .10
	MOVWF med_c
			;	med_b = MOTORSTROM_L;
	MOVLW .10
	MOVWF med_b
			;	
			;}
	RETURN
			;
			;//
			;// Strommessung ber ADC-Eingang AN0
			;// AD-Wert wird in das Filterelement C geschrieben
			;//
			;void strom_messen(void)
			;{
strom_messen
			;		
			;	ADCON0=	 0b0100.0001;	// Fosc/8, Channel AN0, GO, AD_ON
	MOVLW .65
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF ADCON0
			;	GO = 1;			// Wandlung starten
	BSF   0x1F,GO
			;	
			;	while (GO);		// Auf ADC warten
m026	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS 0x1F,GO
	GOTO  m027
	GOTO  m026
			;	
			;	// Overflow abfangen
			;	if (ADRESH)
m027	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  ADRESH,W
	BTFSC 0x03,Zero_
	GOTO  m028
			;	{
			;		med_c = 0xFF;	
	MOVLW .255
	MOVWF med_c
			;	}
			;	else
	GOTO  m029
			;	{
			;		med_c = ADRESL;
m028	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  ADRESL,W
	BCF   0x03,RP0
	MOVWF med_c
			;	}
			;	
			;}
m029	RETURN
			;
			;
			;
			;/*------------------------------------------------------------------*/
			;/*     M     M    A    II  N   N                                    */
			;/*     MM   MM   A A   II  NN  N                                    */
			;/*     M M M M  A   A  II  N N N                                    */
			;/*     M  M  M  AAAAA  II  N  NN                                    */
			;/*     M     M  A   A  II  N   N                                    */
			;/*------------------------------------------------------------------*/
			;
			;void main (void)
			;{
main
			;
			;	uns8 akt_status;
			;		
			;	init();
	CALL  init
			;	
			;		
			;	while (1)
			;	{
			;		
			;		// wenn nichts zu tun
			;		if (soll_status == ST_IDLE)
m030	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  soll_status,1
	BTFSS 0x03,Zero_
	GOTO  m031
			;		{
			;			goto_sleep();	// Gehe schlafen
	CALL  goto_sleep
			;		
			;			Eingang_testen(); // teste Eingangspegel
	CALL  Eingang_testen
			;		}
			;		
			;		
			;		if (soll_status != ST_IDLE)
m031	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  soll_status,1
	BTFSC 0x03,Zero_
	GOTO  m041
			;		{
			;			laufzeit = END_SLEEP;	// default: sofort wieder einschlafen
	MOVLW .220
	MOVWF laufzeit
			;			
			;			if (soll_status == ST_ANKLAPP)
	DECF  soll_status,W
	BTFSS 0x03,Zero_
	GOTO  m032
			;				Delay1ms(5000); // 5s warten (wegen Fehlbedienung)
	MOVLW .136
	MOVWF ms
	MOVLW .19
	MOVWF ms+1
	CALL  Delay1ms
			;			
			;			if (soll_status == ST_AUSKLAPP)
m032	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  soll_status,W
	XORLW .2
	BTFSS 0x03,Zero_
	GOTO  m033
			;			{
			;				// dann ausklappen
			;				ausklappen();
	CALL  ausklappen
			;			}
			;			else if (soll_status == ST_ANKLAPP)
	GOTO  m034
m033	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  soll_status,W
	BTFSS 0x03,Zero_
	GOTO  m034
			;			{
			;				// ansonsten anklappen
			;				anklappen();
	CALL  anklappen
			;			}
			;						
			;			akt_status = soll_status;
m034	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  soll_status,W
	MOVWF akt_status
			;			
			;			
			;			
			;			while (laufzeit < MOTORZEIT_H)
m035	MOVLW .60
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF laufzeit,W
	BTFSC 0x03,Carry
	GOTO  m039
			;			{
			;				Delay1ms(100);	// warten 0,1s
	MOVLW .100
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;				
			;				laufzeit++;	// Zeitscheiben zaehlen
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  laufzeit,1
			;				
			;				strom_messen(); // Motorstrom messen
	CALL  strom_messen
			;				
			;				MedianFilter();	// Filtern
	CALL  MedianFilter
			;				
			;				// Endabschaltung?
			;				if (Motorstrom > MOTORSTROM_H)
	MOVLW .81
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF Motorstrom,W
	BTFSS 0x03,Carry
	GOTO  m036
			;					laufzeit = END_STROM;
	MOVLW .255
	MOVWF laufzeit
			;					
			;				// Kein Strom koennte Leerlauf oder short to GND sein..: abschalten!	
			;				if (Motorstrom < MOTORSTROM_L)
m036	MOVLW .10
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF Motorstrom,W
	BTFSC 0x03,Carry
	GOTO  m037
			;					laufzeit = END_STROM;
	MOVLW .255
	MOVWF laufzeit
			;				
			;				
			;				// hat sich das klappziel gendert?
			;				if (akt_status != soll_status)
m037	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  akt_status,W
	XORWF soll_status,W
	BTFSC 0x03,Zero_
	GOTO  m038
			;					laufzeit = END_RICHTUNG;
	MOVLW .253
	MOVWF laufzeit
			;				
			;			} // von while (laufzeit)
m038	GOTO  m035
			;			
			;			// wenn Motor tatschlich bewegt wurde, stoppen
			;			if (laufzeit != END_SLEEP)
m039	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  laufzeit,W
	XORLW .220
	BTFSC 0x03,Zero_
	GOTO  m040
			;				motor_stop();
	CALL  motor_stop
			;			
			;			// bei berstom und -zeit klappvorgang beenden
			;			if (laufzeit != END_RICHTUNG)
m040	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  laufzeit,W
	XORLW .253
	BTFSC 0x03,Zero_
	GOTO  m041
			;				soll_status = ST_IDLE;
	CLRF  soll_status
			;			
			;			
			;		} // von if != IDLE
			;		
			;	}; // von while(immer)
m041	GOTO  m030

	END


; *** KEY INFO ***

; 0x0077   39 word(s)  1 % : Eingang_testen
; 0x0004   13 word(s)  0 % : int_server
; 0x0011   34 word(s)  1 % : init
; 0x0033   26 word(s)  1 % : Delay1ms
; 0x004D   42 word(s)  2 % : MedianFilter
; 0x009E   11 word(s)  0 % : goto_sleep
; 0x00A9   44 word(s)  2 % : do_pwm
; 0x00D5   32 word(s)  1 % : anklappen
; 0x00F5   26 word(s)  1 % : ausklappen
; 0x010F   25 word(s)  1 % : motor_stop
; 0x0128   24 word(s)  1 % : strom_messen
; 0x0140   96 word(s)  4 % : main

; RAM usage: 19 bytes (5 local), 237 bytes free
; Maximum call level: 2 (+2 for interrupt)
; Total of 413 code words (20 %)
